creator/urls.py
from django.urls import path
from . import views
app_name = 'creator'
urlpatterns = [
    path('buat_tokoh', views.buat_tokoh, name='buat_tokoh'),
    path('buat_warna_kulit', views.buat_warna_kulit, name='buat_warna_kulit'),
    path('buat_level', views.buat_level, name='buat_level'),
    path('buat_menggunakan_apparel', views.buat_menggunakan_apparel, name='buat_menggunakan_apparel'),
    path('buat_misi_utama', views.buat_misi_utama, name='buat_misi_utama'),
    path('buat_menjalankan_misi_utama', views.buat_menjalankan_misi_utama, name='buat_menjalankan_misi_utama'),
    path('buat_makanan', views.buat_makanan, name='buat_makanan'),
    path('buat_makan', views.buat_makan, name='buat_makan'),
    path('buat_kategori_apparel', views.buat_kategori_apparel, name='buat_kategori_apparel'),
    path('buat_rambut', views.buat_rambut, name='buat_rambut'),
    path('pilih_apparel/<str:tokoh>', views.pilih_apparel, name='pilih_apparel'),
    path('buat_koleksi', views.buat_koleksi, name='buat_koleksi'),
    path('buat_mata', views.buat_mata, name='buat_mata'),
    path('buat_rumah', views.buat_rumah, name='buat_rumah'),
    path('buat_barang', views.buat_barang, name='buat_barang'),
    path('buat_apparel', views.buat_apparel, name='buat_apparel'),
    path('buat_koleksi_tokoh',views.buat_koleksi_tokoh,name='buat_koleksi_tokoh'),
]

profil/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('profile_admin', views.read_admin, name='profile_admin'),
    path('profile_pengguna', views.read_pengguna, name='profile_pengguna'),
    path('detail', views.detail, name='detail'),
    path('verifikasi', views.verifikasi, name='verifikasi'),
    path('delete_wishlist/', views.delete_wishlist, name='delete_wishlist')
]

tk_basdat/urls.py
from django.contrib import admin
from django.urls import include, path, re_path
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('', include('authentication.urls')),
    path('read/', include('reader.urls')),
    path('update/', include('updater.urls')),
    path('create/', include('creator.urls')),
    path('delete/', include('deleter.urls')),
    path('profil/', include('profil.urls')),
    path('admin/', admin.site.urls),
]

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

creator/models.py
from django.db import models

# Create your models here.

creator/forms.py
from django import forms

class FormTokoh(forms.Form):
    def __init__(self, *args, **kwargs):
        self.jenis_kelamin_options = kwargs.pop('jenis_kelamin_options')
        self.warna_kulit_options = kwargs.pop('warna_kulit_options')
        self.pekerjaan_options = kwargs.pop('pekerjaan_options')
        super(FormTokoh, self).__init__(*args, **kwargs)
        self.fields['jenis_kelamin'].widget = forms.Select(choices=self.jenis_kelamin_options)
        self.fields['warna_kulit'].widget = forms.Select(choices=self.warna_kulit_options)
        self.fields['pekerjaan'].widget = forms.Select(choices=self.pekerjaan_options)
    nama = forms.CharField(label='Nama', max_length=50)
    jenis_kelamin = forms.CharField(label='Jenis Kelamin')
    warna_kulit = forms.CharField(label='Warna Kulit')
    pekerjaan = forms.CharField(label='Pekerjaan')

class FormWarnaKulit(forms.Form):
    kode = forms.CharField(label='Kode', max_length=10)


class FormLevel(forms.Form):
    level = forms.IntegerField(label='Level')
    xp = forms.IntegerField(label='XP')


class FormMenggunakanApparel(forms.Form):
    def __init__(self, *args, **kwargs):
        self.tokoh_options = kwargs.pop('tokoh_options')
        super(FormMenggunakanApparel, self).__init__(*args, **kwargs)
        self.fields['tokoh'].widget = forms.Select(choices=self.tokoh_options)
    tokoh = forms.CharField(label='Nama Tokoh')

class FormPilihApparel(forms.Form):
    def __init__(self, *args, **kwargs):
        self.apparel_options = kwargs.pop('apparel_options')
        super(FormPilihApparel, self).__init__(*args, **kwargs)
        self.fields['apparel'].widget = forms.Select(choices=self.apparel_options)
    apparel = forms.CharField(label='Apparel')


class FormMisiUtama(forms.Form):
    nama_misi_utama = forms.CharField(label='Nama Misi Utama', max_length=50)
    efek_energi = forms.IntegerField(label='Efek Energi')
    efek_hubungan_sosial = forms.IntegerField(label='Efek Hubungan Sosial')
    efek_kelaparan = forms.IntegerField(label='Efek Kelaparan')
    syarat_energi = forms.IntegerField(label='Syarat Energi')
    syarat_hubungan_sosial = forms.IntegerField(label='Syarat Hubungan Sosial')
    syarat_kelaparan = forms.IntegerField(label='Syarat Kelaparan')
    completion_time = forms.TimeField(label='Completion Time')
    reward_koin = forms.IntegerField(label='Reward Koin')
    reward_xp = forms.IntegerField(label='Reward XP')
    deskripsi = forms.CharField(label='Deskripsi', widget=forms.Textarea)


class FormMenjalankanMisiUtama(forms.Form):
    nama_tokoh = forms.CharField(label='Nama Tokoh', max_length=50)
    nama_misi_utama = forms.CharField(label='Nama Misi Utama', max_length=50)


class FormMakanan(forms.Form):
    nama_makanan = forms.CharField(label='Nama Makanan', max_length=50)
    harga = forms.IntegerField(label='Harga')
    tingkat_energi = forms.IntegerField(label='Tingkat Energi')
    tingkat_kelaparan = forms.IntegerField(label='Tingkat Kelaparan')


class FormMakan(forms.Form):
    nama_tokoh = forms.CharField(label='Nama Tokoh', max_length=50)
    nama_makanan = forms.CharField(label='Nama Makanan', max_length=50)


class FormKategoriApparel(forms.Form):
    nama_kategori = forms.CharField(label='Nama Kategori', max_length=10)

class FormBuatRambut(forms.Form):
    # new_id=forms.CharField(label='new_id',max_length=50)
    harga_jual = forms.IntegerField()
    tipe = forms.CharField(label='tipe', max_length=50)

class FormBuatMata(forms.Form):
    harga_jual = forms.IntegerField()
    warna=forms.CharField(label='warna', max_length=50)

class FormBuatRumah(forms.Form):
    nama=forms.CharField(label='nama',max_length=50)
    harga_jual = forms.IntegerField()
    harga_beli = forms.IntegerField()
    kapasitas_barang=forms.IntegerField()

class FormBuatBarang(forms.Form):
    nama=forms.CharField(label='nama',max_length=50)
    harga_jual = forms.IntegerField()
    harga_beli = forms.IntegerField()
    tingkat_energi=forms.IntegerField()

class FormBuatApparel(forms.Form):
    nama=forms.CharField(label='nama',max_length=50)
    harga_jual = forms.IntegerField()
    harga_beli = forms.IntegerField()
    warna=forms.CharField(label='warna', max_length=50)

class BuatFormApparel(forms.Form):
    nama=forms.CharField(label='nama',max_length=50)
    harga_jual = forms.IntegerField()
    harga_beli = forms.IntegerField()
    warna=forms.CharField(label='warna', max_length=50)
    # kategori_apparel=forms.CharField(label='kategori_apparel', widget=forms.Select(choices=get_kategori_apparel()))
    kategori_apparel=forms.CharField(label='kategori_apparel')
    nama_pekerjaan=forms.CharField(label='nama_pekerjaan')

class CreateKoleksiTokoh(forms.Form):
    nama=forms.CharField(label='nama', max_length=50)
    koleksi=forms.CharField(label='koleksi', max_length=50)

creator/views.py
import datetime
from random import randrange
from django.shortcuts import render, redirect
from django.contrib import messages
from django.db import connection, transaction
from .forms import *
from authentication.views import login
from django.http.response import HttpResponseNotFound, HttpResponseRedirect
from django.shortcuts import redirect, render
from collections import namedtuple
from django.views.decorators.csrf import csrf_exempt


# Create your views here.

def namedtuplefetchall(cursor):
    desc = cursor.description
    nt_result = namedtuple('Result', [col[0] for col in desc])
    return [nt_result(*row) for row in cursor.fetchall()]
def buat_tokoh(request):
    if "isLogin" not in request.session:
        return login(request)
    response = {}
    if request.session['role'] == 'Admin':
        messages.info(request, 'This page is restricted to players only.')
    elif request.session['role'] == 'Pemain':
        """input = request.POST['kode']
        cursor = connection.cursor()
        try :
            cursor.execute("INSERT INTO THE_CIMS.WARNA_KULIT(kode) VALUES ('"+input+"')")
            cursor.close()
            return redirect('/read/list_warna_kulit')
        except Exception as e:
            message = str(e)
            if "Skin" in message :
                message = message[:57]
                messages.info(request, message)"""
        if request.method == 'POST':
            message = ""
            input_nama = request.POST['nama']
            input_jenis_kelamin = request.POST['jenis_kelamin']
            input_warna_kulit = request.POST['warna_kulit']
            input_pekerjaan = request.POST['pekerjaan']
            list_sifat = []
            cursor = connection.cursor()
            try:
                with connection.cursor() as cursor:
                    cursor.execute(f"SELECT nama_sifat FROM THE_CIMS.sifat")
                    list_sifat = cursor.fetchall()
                    sifat = list_sifat[randrange(len(list_sifat))][0]
                    cursor.execute(f"""INSERT INTO the_cims.tokoh(username_pengguna, nama, jenis_kelamin, warna_kulit, sifat, pekerjaan)
                    VALUES ('{request.session['username']}', '{input_nama}', '{input_jenis_kelamin}', '{input_warna_kulit}', '{sifat}',
                    '{input_pekerjaan}')""")
                    cursor.close()
                return redirect('/read/list_tokoh')
            except Exception as e:
                messages.info(request, str(e))
        list_jenis_kelamin = [('Laki-laki', 'Laki-laki'), ('Perempuan', 'Perempuan')]
        list_warna_kulit = []
        list_pekerjaan = []
        try:
            with connection.cursor() as cursor:
                cursor.execute(
                    f"SELECT kode, kode FROM THE_CIMS.warna_kulit")
                list_warna_kulit = cursor.fetchall()
                cursor.execute(
                    f"SELECT nama, nama FROM THE_CIMS.pekerjaan")
                list_pekerjaan = cursor.fetchall()
        except Exception as e:
            messages.info(request, str(e))
        response['error'] = False
        form = FormTokoh(request.POST or None, jenis_kelamin_options=list_jenis_kelamin,
                         warna_kulit_options=list_warna_kulit, pekerjaan_options=list_pekerjaan)
        response['form'] = form
    else:
        return login(request)
    return render(request, 'buat_tokoh.html', response)


def buat_warna_kulit(request):
    if "isLogin" not in request.session:
        return login(request)
    response = {}
    if request.session['role'] == 'Admin':
        if request.method == 'POST':
            message = ""
            input = request.POST['kode']
            cursor = connection.cursor()
            try:
                cursor.execute("INSERT INTO THE_CIMS.WARNA_KULIT(kode) VALUES ('" + input + "')")
                cursor.close()
                return redirect('/read/list_warna_kulit')
            except Exception as e:
                message = str(e)
                if "Skin" in message:
                    message = message[:57]
                messages.info(request, message)
        response['error'] = False
        form = FormWarnaKulit(request.POST or None)
        response['form'] = form
    elif request.session['role'] == 'Pemain':
        messages.info(request, 'This page is restricted to admins only.')
    else:
        return login(request)
    return render(request, 'buat_warna_kulit.html', response)


def buat_level(request):
    if "isLogin" not in request.session:
        return login(request)
    response = {}
    if request.session['role'] == 'Admin':
        if request.method == 'POST':
            message = ""
            input_level = request.POST['level']
            input_xp = request.POST['xp']
            cursor = connection.cursor()
            try:
                cursor.execute(
                    "INSERT INTO THE_CIMS.LEVEL(level, xp) VALUES ('" + input_level + "','" + input_xp + "')")
                cursor.close()
                return redirect('/read/list_level')
            except Exception as e:
                message = str(e)
                messages.info(request, message)
        response['error'] = False
        form = FormLevel(request.POST or None)
        response['form'] = form
    elif request.session['role'] == 'Pemain':
        messages.info(request, 'This page is restricted to admins only.')
    else:
        return login(request)
    return render(request, 'buat_level.html', response)


def buat_kategori_apparel(request):
    cursor = connection.cursor()
    if "isLogin" not in request.session:
        return login(request)

    if request.session['role'] == 'Admin':
        print ("masuk admin")

        cursor.execute("SET SEARCH_PATH TO the_cims")
        if request.method == "POST":
            print("masuk post")
            nama_kategori = request.POST.get("nama_kategori")
            print(nama_kategori)
            if not nama_kategori:
                message = "Data yang diisikan belum lengkap, silahkan lengkapi data terlebih dahulu."
                return render(request, 'buat_kategori_apparel.html', {'message':message})
            else:
                cursor.execute(f"INSERT INTO kategori_apparel VALUES ('{nama_kategori}')")
                return redirect("/read/list_kategori_apparel")
        else:
            return render(request, 'buat_kategori_apparel.html')
    elif request.session['role'] == 'Pemain':
        messages.info(request, 'This page is restricted to admins only.')
    else:
        return login(request)


def buat_koleksi(request):
    if "isLogin" not in request.session:
        return login(request)
    response = {}
    if request.session['role'] == 'Admin':
        response['error'] = False
        form = FormKategoriApparel(request.POST or None)
        response['form'] = form
    elif request.session['role'] == 'Pemain':
        messages.info(request, 'This page is restricted to admins only.')
    else:
        return login(request)
    return render(request, 'buat_koleksi.html', response)


def buat_menggunakan_apparel(request):
    if "isLogin" not in request.session:
        return login(request)
    response = {}
    if (request.session['role'] == 'Admin'):
        messages.info(request, 'This page is restricted to players only.')
    elif (request.session['role'] == 'Pemain'):
        if request.method == 'POST':
            message = ""
            input = request.POST['tokoh']
            url = '/create/pilih_apparel/' + input
            return redirect(url)
        list_tokoh = []
        try:
            with connection.cursor() as cursor:
                cursor.execute(
                    f"SELECT nama, nama FROM THE_CIMS.TOKOH WHERE username_pengguna='{request.session['username']}'")
                list_tokoh = cursor.fetchall()
        except Exception as e:
            messages.info(request, str(e))
        response['error'] = False
        form = FormMenggunakanApparel(request.POST or None, tokoh_options=list_tokoh)
        response['form'] = form
    else:
        return login(request)
    return render(request, 'buat_menggunakan_apparel.html', response)


def pilih_apparel(request, tokoh):
    response = {}
    if request.method == 'POST':
        message = ""
        apparel = request.POST['apparel']
        cursor = connection.cursor()
        try:
            cursor.execute(
                f"INSERT INTO the_cims.menggunakan_apparel(username_pengguna, nama_tokoh, id_koleksi) VALUES ('{request.session['username']}', '{tokoh}', '{apparel}')")
            cursor.close()
            return redirect('/read/list_menggunakan_apparel')
        except Exception as e:
            message = str(e)
            messages.info(request, message)
    response['tokoh'] = tokoh
    list_apparel = []
    try:
        with connection.cursor() as cursor:
            cursor.execute(
                f"SELECT id_koleksi, id_koleksi FROM the_cims.koleksi_tokoh WHERE id_koleksi LIKE 'AP%' AND nama_tokoh = '{tokoh}'")
            list_apparel = cursor.fetchall()
    except Exception as e:
        messages.info(request, str(e))
    response['error'] = False
    form = FormPilihApparel(request.POST or None, apparel_options=list_apparel)
    response['form'] = form
    return render(request, 'pilih_apparel.html', response)


@transaction.atomic
def buat_misi_utama(request):
    if "isLogin" not in request.session:
        return login(request)
    response = {}
    if request.session['role'] == 'Admin':
        if request.method == 'POST':
            nama_misi_utama = request.POST['nama_misi_utama']
            efek_energi = request.POST['efek_energi']
            efek_hubungan_sosial = request.POST['efek_hubungan_sosial']
            efek_kelaparan = request.POST['efek_kelaparan']
            syarat_energi = request.POST['syarat_energi']
            syarat_hubungan_sosial = request.POST['syarat_hubungan_sosial']

creator/templates/buat_apparel.html
{% extends 'base.html' %}
{% block content %}

{% for message in messages %}
<div class="container-fluid p-0" xmlns:th="http://www.w3.org/1999/xhtml" xmlns:th="http://www.w3.org/1999/xhtml"
     xmlns:th="http://www.w3.org/1999/xhtml">
    <div class="alert alert-danger {{ message.tags }} alert-dismissible" role="alert" >
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="True">&times;</span>
        </button>
        {{ message }}
    </div>
</div>
{% endfor %}

{% if request.session.role == "Admin" %}
<h2>FORM BUAT APPAREL</h2>
<form action="" method="POST">
    {% csrf_token %}
    <p>Id</p>
    <p><input type="username" name="username" value= 'AP{{id}}' disabled></p>
    <p>Nama Apparel</p>
    <p><input type="nama" name="nama"></p>
    <p>Harga Jual</p>
    <p><input type="harga" name="harga_jual"></p>
    <p>Harga Beli</p>
    <p><input type="harga" name="harga_beli"></p>
    <p>Warna Apparel</p>
    <p><input type="warna" name="warna"></p>
    <p>Kategori Apparel</p>
    <p>
        <select name="kategori_apparel">
            {% for i in kategori_apparel %}
            <option value="{{i.nama_kategori}}">{{i.nama_kategori}}</option>
            {% endfor %}
        </select>
    </p>
    <p>Nama Pekerjaan</p>
    <p>
        <select name="nama_pekerjaan">
            {% for i in nama_pekerjaan %}
            <option value="{{i.nama}}">{{i.nama}}</option>
            {% endfor %}
        </select>
    </p>
    <button type="submit">SIMPAN</button>
    {% if error %}
    <h1 style="color: red">Ada yang salah, mohon ulangi.</h1>
    {% endif %}
</form>
</body>
</html>
{% endif %}
{% endblock content %}

creator/templates/buat_barang.html
{% extends 'base.html' %}
{% block content %}

{% for message in messages %}
<div class="container-fluid p-0" xmlns:th="http://www.w3.org/1999/xhtml" xmlns:th="http://www.w3.org/1999/xhtml"
     xmlns:th="http://www.w3.org/1999/xhtml">
    <div class="alert alert-danger {{ message.tags }} alert-dismissible" role="alert" >
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="True">&times;</span>
        </button>
        {{ message }}
    </div>
</div>
{% endfor %}

{% if request.session.role == "Admin" %}
<h2>FORM BUAT BARANG</h2>
<form action="" method="POST">
    {% csrf_token %}
    <p>Id</p>
    <p><input type="username" name="username" value= 'BR{{id}}' disabled></p>
    <p>Nama Barang</p>
    <p><input type="nama" name="nama"></p>
    <p>Harga Jual</p>
    <p><input type="harga" name="harga_jual"></p>
    <p>Harga Beli</p>
    <p><input type="harga" name="harga_beli"></p>
    <p>Tingkat Energi</p>
    <p><input type="tingkat_energi" name="tingkat_energi"></p>
    <button type="submit">SIMPAN</button>
    {% if error %}
    <h1 style="color: red">Ada yang salah, mohon ulangi.</h1>
    {% endif %}
</form>
</body>
</html>
{% endif %}
{% endblock content %}

creator/templates/buat_kategori_apparel.html
{% extends 'base.html' %}
{% block content %}

  {% for message in messages %}
<div class="container-fluid p-0" xmlns:th="http://www.w3.org/1999/xhtml" xmlns:th="http://www.w3.org/1999/xhtml"
     xmlns:th="http://www.w3.org/1999/xhtml">
    <div class="alert alert-danger {{ message.tags }} alert-dismissible" role="alert" >
      <button type="button" class="close" data-dismiss="alert" aria-label="Close">
        <span aria-hidden="True">&times;</span>
      </button>
      {{ message }}
    </div>
  </div>
  {% endfor %}

  {% if request.session.role == "Admin" %}
<h2>Form Buat Kategori Apparel</h2>
    <form action="" method="POST">
        {%csrf_token%}
        <div class="form-outline mb-4">
            <label class="form-label" for="nama_kategori">Nama Kategori</label>
            <input id="nama_kategori" type="text" name="nama_kategori" class="form-control" placeholder="Input ..." />
        </div>
        <p>{{message}}</p>
        <div class="text-center pt-1 mb-5 pb-1">
            <button class="btn btn-primary btn-block fa-lg gradient-custom-2 mb-3" type="submit" value="Submit">Simpan</button>
        </div>
    </form>
{% endif %}
{% endblock content %}

creator/templates/buat_koleksi.html
{% extends 'base.html' %}
{% block content %}

{% for message in messages %}
<div class="container-fluid p-0" xmlns:th="http://www.w3.org/1999/xhtml" xmlns:th="http://www.w3.org/1999/xhtml"
     xmlns:th="http://www.w3.org/1999/xhtml">
    <div class="alert alert-danger {{ message.tags }} alert-dismissible" role="alert" >
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="True">&times;</span>
        </button>
        {{ message }}
    </div>
</div>
{% endfor %}

{% if request.session.role == "Admin" %}
<table class="table">
    <thead><tr>
        <th scope="col">Menu Buat Koleksi</th>
    </tr></thead>
    <tr scope="row">
        <td>
            <a href="/create/buat_rambut" style="text-decoration: none">
            <input  type="button" class="btn btn-primary btn-block btn-lg" value="Rambut">
            </a>
        </td>
    </tr>
    <tr scope="row">
        <td>
            <a href="/create/buat_mata" style="text-decoration: none">
                <input  type="button" class="btn btn-primary btn-block btn-lg" value="Mata">
            </a>
        </td>
    </tr>
    <tr scope="row">
        <td>
            <a href="/create/buat_rumah" style="text-decoration: none">
                <input  type="button" class="btn btn-primary btn-block btn-lg" value="Rumah">
            </a>
        </td>
    </tr>
    <tr scope="row">
        <td>
            <a href="/create/buat_barang" style="text-decoration: none">
                <input  type="button" class="btn btn-primary btn-block btn-lg" value="Barang">
            </a>
        </td>
    </tr>
    <tr scope="row">
        <td>
            <a href="/create/buat_apparel" style="text-decoration: none">
                <input  type="button" class="btn btn-primary btn-block btn-lg" value="Apparel">
            </a>
        </td>
    </tr>
</table>
{% endif %}
{% endblock content %}

creator/templates/buat_makan.html
{% extends 'base.html' %}
{% block content %}

<div class="container" style="margin-top: 50px; text-align: center;">
    {% for message in messages %}
    <div class="container-fluid p-0">
        <div class="alert alert-danger {{ message.tags }} alert-dismissible" role="alert" >
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="True">&times;</span>
        </button>
        {{ message }}
        </div>
    </div>
    {% endfor %}
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Form Buat Makan</title>
    </head>
<body>
    {% if request.session.role == "Pemain" %}
    <h2>Form Buat Makan</h2>
    <form action="{% url 'creator:buat_makan' %}" method="post">
        {%csrf_token%}
        <label class="label" for="nama_tokoh">Nama Tokoh:</label>
        <select class="form-control" name="nama_tokoh" id="nama_tokoh" >
          {%for tokoh in list_tokoh %}
          <option value="{{tokoh.0}}">{{tokoh.0}}</option>
          {% endfor %}
        </select>
        <br>
        <label class="label" for="nama_makanan">Nama Misi Utama:</label>
        <select class="form-control" name="nama_makanan" id="nama_makanan" >
          {%for makanan in list_makanan %}
          <option value="{{makanan.0}}">{{makanan.0}}</option>
          {% endfor %}
        </select>
        <br>
        <button type="submit">
            SIMPAN
        </button>
    </form>
    {% endif %}
</body>
</div>

{% endblock content %}

creator/templates/buat_mata.html
{% extends 'base.html' %}
{% block content %}

{% for message in messages %}
<div class="container-fluid p-0" xmlns:th="http://www.w3.org/1999/xhtml" xmlns:th="http://www.w3.org/1999/xhtml"
     xmlns:th="http://www.w3.org/1999/xhtml">
    <div class="alert alert-danger {{ message.tags }} alert-dismissible" role="alert" >
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="True">&times;</span>
        </button>
        {{ message }}
    </div>
</div>
{% endfor %}

{% if request.session.role == "Admin" %}
<h2>FORM BUAT MATA</h2>
<form action="" method="POST">
    {% csrf_token %}
    <p>Id</p>
    <p><input id="new_id" type="text" name="new_id" value="MT{{id}}" disabled></p>
    <p>Harga Jual</p>
    <p><input type="number" name="harga_jual"></p>
    <p>Warna Mata</p>
    <p><input type="text" name="warna"></p>
    <button type="submit">SIMPAN</button>
    {% if error %}
    <h1 style="color: red">Ada yang salah, mohon ulangi.</h1>
    {% endif %}
</form>
</body>
</html>
{% endif %}
{% endblock content %}

creator/templates/buat_menjalankan_misi_utama.html
{% extends 'base.html' %}
{% block content %}

<div class="container" style="margin-top: 50px; text-align: center;">
    <div id="alert_required_fields" class="container-fluid p-0"></div>
    {% for message in messages %}
    <div class="container-fluid p-0">
        <div class="alert alert-danger {{ message.tags }} alert-dismissible" role="alert" >
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="True">&times;</span>
        </button>
        {{ message }}
        </div>
    </div>
    {% endfor %}
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Form Buat Menjalankan Misi Utama</title>
    </head>
<body>
    {% if request.session.role == "Pemain" %}
    <h2>Form Buat Menjalankan Misi Utama</h2>
    <form action="{% url 'creator:buat_menjalankan_misi_utama' %}" method="post">
        {%csrf_token%}
        <label class="label" for="nama_tokoh">Nama Tokoh:</label>
        <select class="form-control" name="nama_tokoh" id="nama_tokoh" >
          {%for tokoh in list_tokoh %}
          <option value="{{tokoh.0}}">{{tokoh.0}}</option>
          {% endfor %}
        </select>
        <br>
        <label class="label" for="nama_misi_utama">Nama Misi Utama:</label>
        <select class="form-control" name="nama_misi_utama" id="nama_misi_utama" >
          {%for misi in list_misi_utama %}
          <option value="{{misi.0}}">{{misi.0}}</option>
          {% endfor %}
        </select>
        <br>
        <button type="submit">
            SIMPAN
        </button>
    </form>
    {% endif %}
</body>
</div>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js" ></script>
<script>
        $(document).ready(function () {
            var allRequiredInput = $("input[required]").add('textarea');
            allRequiredInput.on('invalid', function(){
                console.log("halo kak")
                alert_required_fields.innerHTML = `
                                    <div class="container-fluid p-0">
                                        <div class="alert alert-danger {{ message.tags }} alert-dismissible" role="alert" >
                                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                            <span aria-hidden="True">&times;</span>
                                        </button>
                                        Data yang diisikan belum lengkap, silahkan lengkapi data terlebih dahulu
                                        </div>
                                    </div>`
            });
        });
    </script>
{% endblock content %}